package com.jiayue.insu.incloud.controller;

import cn.hutool.core.date.DateUtil;
import com.jiayue.insu.common.core.util.R;
import com.jiayue.insu.incloud.entity.Quartz;
import com.jiayue.insu.incloud.quartz.ScheduledTask;
import org.quartz.SchedulerException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.text.ParseException;

@RestController
@RequestMapping("/test")
public class TestController {
   @GetMapping
    public R test(){
       return R.ok("ok");
   }

    @Autowired
    ScheduledTask scheduledTask;

    @GetMapping("/job")
    public R testJob() throws ClassNotFoundException, SchedulerException, ParseException {
        Quartz quartz = new Quartz();
        quartz.setExecuteClass("com.jiayue.insu.incloud.quartz.job.TestJob");
        quartz.setCronExpression("30 0/1 * * * ?");
        quartz.setJobName("testJob2");
        quartz.setStartTime(DateUtil.current());
        Class c = Class.forName(quartz.getExecuteClass());
        scheduledTask.scheduleJob(c,quartz.getJobName(),quartz.getStartTime(),quartz.getCronExpression(),null);
        return R.ok();
    }
}
